-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt
-- active center differential 

local M = {}
M.type = "auxilliary"
M.relevantDevice = "differential"

local differential = nil
local diffLockCoef = 0.05


local function updateGFX()
  if not differential then return end
  local throttle = electrics.values['throttle_input'];
  local steer = electrics.values['steering_input'];
  local absSteer = math.abs(steer);
  if electrics.values['diffMode'] == 0 then  --Tarmac
  diffLockCoef = throttle * math.pow(absSteer, 0.3) * 0.2
  --differential.diffTorqueSplitA = throttle * math.pow((steer * 0.5 + 0.5), 1)
  differential.diffTorqueSplitB = 0.5
  log('I', "Mode", "Tarmac")  
  end 
  if electrics.values['diffMode'] == 1 then  --Dirt
  diffLockCoef = throttle * math.pow(absSteer, 0.3) * 0.2
  differential.diffTorqueSplitB = 0.5
  end
  if electrics.values['diffMode'] == 2 then --Snow
  diffLockCoef = throttle * math.pow(absSteer, 0.3) * 0.2
  differential.diffTorqueSplitB = 0.5
  end
  if electrics.values['diffMode'] == 3 then --Drift
  diffLockCoef = throttle * math.pow(absSteer, 0.3) * 0.2
  differential.diffTorqueSplitA = 0.5
  --differential.diffTorqueSplitB = throttle * math.pow((steer * 0.5 + 0.5), 1) 
  end
  
  differential.lsdLockCoef = 0.1 + throttle * (absSteer * 0.6) * diffLockCoef
  differential.diffTorqueSplitA = 1 - differential.diffTorqueSplitB
  differential.lsdRevLockCoef = differential.lsdLockCoef
  
end

local function init(jbeamData)
  differential = powertrain.getDevice(jbeamData.transfercaseName)
  if differential then 
  log('I', "Found", "Rear Diff")
  differential.lsdLockCoef = 0.1
  differential.lsdRevLockCoef = 0.05
  differential.lsdPreLoad = 20
  differential.diffTorqueSplit = 0.5
  end
end

M.init = init
--M.reset = init
M.updateGFX = updateGFX

return M